<?php

namespace ApiQL\Language\Interpreters;

use ApiQL\Language\AbstractLanguage;
use ApiQL\Language\LanguageFactory;

/**
 * Class AndInterpreter
 *
 * @package ApiQL\Language\Interpreters
 */
class AndInterpreter extends AbstractLanguage
{
    /**
     * Execute logical AND expression
     */
    public function execute()
    {
        $expressions = array_map(function ($params) {
            $interpreter = LanguageFactory::build($params);
            return $interpreter->execute();
        }, $this->expression);
        return self::$builder->andX(...$expressions);
    }
}
