<?php

namespace ApiQL\Language\Interpreters;

use ApiQL\Language\AbstractLanguage;
use ApiQL\Language\LanguageFactory;

/**
 * Class OrInterpreter
 *
 * @package ApiQL\Language\Interpreters
 */
class OrInterpreter extends AbstractLanguage
{
    /**
     * Execute logical OR expression
     */
    public function execute()
    {
        $expressions = array_map(function ($params) {
            $interpreter = LanguageFactory::build($params);
            return $interpreter->execute();
        }, $this->expression);
        return self::$builder->orX(...$expressions);
    }
}
