<?php

namespace ApiQL\Language\Interpreters;

use ApiQL\Language\AbstractLanguage;

/**
* Class SpecInterpreter
*
* @package ApiQL\Language\Interpreters
*/
class SpecInterpreter extends AbstractLanguage
{
    /**
     * Execute specification expression with value provided as an array
     */
    public function execute()
    {
        // spec format may be like "NotIn" or "not_in"
        $specName = implode('', array_map(function ($word) {
            return ucfirst($word);
        }, explode('_', $this->expression['spec'])));
        $key = array_key_exists('data', $this->expression) ? 'data' : 'field';
        // may be not data|field key in expression, like in ?spec=in&a=1
        if (!array_key_exists($key, $this->expression)) {
            unset($this->expression['spec']);
            $value = $this->expression;
        } else {
            $value = $this->expression[$key];
        }
        if (!empty(self::$specs) && array_key_exists($specName, self::$specs)) {
            return self::$builder->spec(self::$specs[$specName], $value);
        }
        return null;
    }
}
