<?php

namespace ApiQL\Language\Specs;

use Doctrine\DBAL\Query\QueryBuilder;
use ApiQL\Language\JsonField;

/**
* Class IsNotNull
*
* @package ApiQL\Language\Specs
*/
class IsNotNull
{
    use JsonField;

    private $field;

    public function __construct(string $field)
    {
        $this->field = $field;
    }

    public function match(QueryBuilder $queryBuilder)
    {
        $fieldValue = $this->getJsonFieldValue($this->field);
        return $queryBuilder->expr()->isNotNull($fieldValue);
    }
}
