<?php

namespace ApiQL\Language\Specs;

use Doctrine\DBAL\Query\QueryBuilder;
use ApiQL\Language\JsonField;

/**
* Class LessThanOrEqual
*
* @package ApiQL\Language\Specs
*/
class LessThanOrEqual
{
    use JsonField;

    private $parameter;
    private $value;

    public function __construct(string $parameter, $value)
    {
        $this->parameter = $parameter;
        $this->value = $value;
    }

    public function match(QueryBuilder $queryBuilder)
    {
        $fieldName = $this->getJsonFieldName($this->parameter, $this->value);
        $fieldValue = $this->getJsonFieldValue($this->parameter, $this->value);
        $queryBuilder->setParameter($fieldName, $this->getJsonPropertyValue($this->value));
        return $queryBuilder->expr()->lte($fieldValue, sprintf(":%s", $fieldName));
    }
}
