<?php

namespace ApiQL\Language\Specs;

use Doctrine\DBAL\Query\QueryBuilder;
use ApiQL\Language\JsonField;

/**
* Class NotIn
*
* @package ApiQL\Language\Specs
*/
class NotIn
{
    use JsonField;

    private $parameter;
    private $value;

    public function __construct(string $parameter, $value)
    {
        $this->parameter = $parameter;
        $this->value = $value;
    }

    public function match(QueryBuilder $queryBuilder)
    {
        $fieldValue = $this->getJsonFieldValue($this->parameter, $this->value, true);
        $value = $this->getJsonPropertyValue($this->value);
        $value = is_string($value) ? explode(',', $value) : $value;
        return $queryBuilder->expr()->notIn($fieldValue, $value);
    }
}
